%Matlab code to simulate Friis Free space equation
%-----------Input section------------------------
Pt_dBm=52; %Input – Transmitted power in dBm
Gt_dBi=25; %Gain of the Transmitted antenna in dBi
Gr_dBi=15; %Gain of the Receiver antenna in dBi
f=1*10^9; %Transmitted signal frequency in Hertz 
d =41935000*(1:1:200) ; %Array of input distances in meters
L=1; %Other System Losses, No Loss case L=1
n=2; %Path loss exponent for Free space
%----------------------------------------------------
[PL,Pr_dBm] = FriisModel(Pt_dBm,Gt_dBi,Gr_dBi,f,d,L,n);
plot(log10(d),Pr_dBm); title('Friis Path loss model');
xlabel('log10(d)'); ylabel('P_r (dBm)');