Pt_dBm=52; %Input transmitted power in dBm
Gt_dBi=25; %Gain of the Transmitted antenna in dBi
Gr_dBi=15; %Gain of the Receiver antenna in dBi
f=1*10^9; %Transmitted signal frequency in Hertz 
d0=1; %assume reference distance = 1m
d=100*(1:0.2:100); %Array of distances to simulate
L=1; %Other System Losses, No Loss case L=1
sigma=6;%Standard deviation of log Normal distribution (in dB)
n=3.5; % path loss exponent

%Friis transmission (no shadowing effect)
[PL_Friss,Pr_Friss] = FriisModel(Pt_dBm,Gt_dBi,Gr_dBi,f,d,L,n);

figure; plot(log10(d),Pr_Friss,'b'); hold on;
%Log normal shadowing (with shadowing effect)
for i=1:50 %To see randomness, simulate 50 points for every distance
  [PL_shadow,Pr_shadow] = logNormalShadowing(Pt_dBm,Gt_dBi,Gr_dBi,f,d0,d,L,sigma,n);
  plot(log10(d),Pr_shadow,'r*');
end

xlabel('log10(d)'); ylabel('P_r (dBm)'); axis tight;
title('Log Normal Shadowing Model');
legend('no shadowing','log normal shadowing');