function [s,ref]=mqam_modulator(M,a)
%Function to MQAM modulate the vector of data symbols - a
%[s,ref]=mqam_modulator(M,a) modulates the symbols defined by the vector a using
%MQAM modulation, where M specifies the order of M-QAM modulation and the
%vector d contains symbols whose values range 1:M. The output s is the
%modulated output and ref represents the reference constellation that can
%be used during demodulation
  ref=constructQAM(M); %construct reference constellation
  s=ref(a); %map information symbols to modulated symbols
end